Package org.eclipse.ui

## Class BasicWorkingSetElementAdapter

- java.lang.Object
- - org.eclipse.ui.BasicWorkingSetElementAdapter

All Implemented Interfaces:
  `IExecutableExtension`, `IWorkingSetElementAdapter`

    public final class BasicWorkingSetElementAdapter
    extends Object
    implements IWorkingSetElementAdapter, IExecutableExtension

Basic IWorkingSetElementAdapter implementation that allows plugins to decribe simple declarative element adapters.

The executable extension format for this class is as follows:

     <workingSet elementAdapterClass="org.eclipse.ui.BasicWorkingSetElementAdapter:class1.to.adapt.to[;option1=value1][;option2=value2],class2.to.adapt.to[;option1=value1][;option2=value2],...">
     ...
     </workingSet>

The valid options are:

adapt
  Values: `true` or `true`. Specifies whether or not the platform `IAdapterManager` and the `IAdaptable` interface should be consulted.

Please see the `adaptElements(IWorkingSet, IAdaptable[])` method for details on behavior of this implementation.

Since:
  3.3

### Constructor Summary

Constructors
`BasicWorkingSetElementAdapter()`

### Method Summary

All Methods Instance Methods Concrete Methods
`IAdaptable[]` `adaptElements​(IWorkingSet ws, IAdaptable[] elements)` When invoked this method will iterate over all classes specified as IExecutableExtension arguements to this class in order and compare with the elements.
`void` `dispose()` Disposes of this element adaptor.
`void` `setInitializationData​(IConfigurationElement config, String propertyName, Object data)` This method is called by the implementation of the method `IConfigurationElement.createExecutableExtension` on a newly constructed extension, passing it its relevant configuration information.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### BasicWorkingSetElementAdapter

    public BasicWorkingSetElementAdapter()

### Method Detail

#### adaptElements

    public IAdaptable[] adaptElements​(IWorkingSet ws,
                                      IAdaptable[] elements)

When invoked this method will iterate over all classes specified as IExecutableExtension arguements to this class in order and compare with the elements. If the element is directly assignable to the provided class then it is added to the result array as is. If the class has specified "adapt=true" as an argument and there is an available adapter in the platform IAdapterManager then it is returned. Finally, if "adapt=true" and the class is already loaded (determined by inspecting exported bundles via the platform PackageAdmin) a direct query for the adapter is made on the object and if it is not `null` then it is returned.

A consequence of the above is that it is possible for this method to return differing results based on the state of bundles loaded within the system.

Specified by:
  `adaptElements` in interface `IWorkingSetElementAdapter`
Parameters:
  `ws` - the target working set that elements should be adapted for
  `elements` - the elements to adapt
Returns:
  the (possibly adapted) elements to add to/remove from the working set
See Also:
  `IWorkingSetElementAdapter.adaptElements(org.eclipse.ui.IWorkingSet, org.eclipse.core.runtime.IAdaptable[])`, `IAdapterManager.getAdapter(Object, String)`, `PackageAdmin.getExportedPackage(String)`

#### dispose

    public void dispose()

Description copied from interface: `IWorkingSetElementAdapter`
Disposes of this element adaptor.

Specified by:
  `dispose` in interface `IWorkingSetElementAdapter`

#### setInitializationData

    public void setInitializationData​(IConfigurationElement config,
                                      String propertyName,
                                      Object data)

Description copied from interface: `IExecutableExtension`
This method is called by the implementation of the method `IConfigurationElement.createExecutableExtension` on a newly constructed extension, passing it its relevant configuration information. Most executable extensions only make use of the first two call arguments.

Regular executable extensions specify their Java implementation class name as an attribute of the configuration element for the extension. For example

         <action run="com.example.BaseAction"/>

In the above example, this method would be called with a reference to the `<action>` element (first argument), and `"run"` as the name of the attribute that defined this executable extension (second argument).

The last parameter is for the specific use of extension adapters and is typically not used by regular executable extensions.

There are two supported ways of associating additional adapter-specific data with the configuration in a way that is transparent to the extension point implementor:

(1) by specifying adapter data as part of the implementation class attribute value. The Java class name can be followed by a ":" separator, followed by any adapter data in string form. For example, if the extension point specifies an attribute `"run"` to contain the name of the extension implementation, an adapter can be configured as

         <action run="com.example.ExternalAdapter:./cmds/util.exe -opt 3"/>

(2) by converting the attribute used to specify the executable extension to a child element of the original configuration element, and specifying the adapter data in the form of xml markup. Using this form, the example above would become

         <action>
             <run class="com.xyz.ExternalAdapter">
                 <parameter name="exec" value="./cmds/util.exe"/>
                 <parameter name="opt"  value="3"/>
             </run>
         </action>

Form (2) will typically only be used for extension points that anticipate the majority of extensions configured into it will in fact be in the form of adapters.

In either case, the specified adapter class is instantiated using its 0-argument public constructor. The adapter data is passed as the last argument of this method. The data argument is defined as Object. It can have the following values:

- `null`, if no adapter data was supplied
- in case (1), the initialization data string is passed as a `String`
- in case (2), the initialization data is passed as a `Hashtable` containing the actual parameter names and values (both `String`s)

Specified by:
  `setInitializationData` in interface `IExecutableExtension`
Parameters:
  `config` - the configuration element used to trigger this execution. It can be queried by the executable extension for specific configuration properties
  `propertyName` - the name of an attribute of the configuration element used on the `createExecutableExtension(String)` call. This argument can be used in the cases where a single configuration element is used to define multiple executable extensions.
  `data` - adapter data in the form of a `String`, a `Hashtable`, or `null`.
See Also:
  `IConfigurationElement.createExecutableExtension(String)`